#ifndef _EYRIE_MAIN_FORM_H_
#define _EYRIE_MAIN_FORM_H_

#include <FBase.h>
#include <FUi.h>
#include <FNet.h>
#include <FMedia.h>

using namespace Tizen::Net::Http;

#define MAX_BUFFER_COUNT 3

class eyrieMainForm
	: public Tizen::Ui::Controls::Form
	, public Tizen::Ui::IActionEventListener
	, public Tizen::Ui::Controls::IFormBackEventListener
 	, public Tizen::Ui::Scenes::ISceneEventListener
 	, public Tizen::Media::IAudioInEventListener
 	, public Tizen::Net::Http::IHttpTransactionEventListener
{
public:
	eyrieMainForm(void);
	virtual ~eyrieMainForm(void);
	bool Initialize(void);

public:
	virtual result OnInitializing(void);
	virtual result OnTerminating(void);
	virtual void OnActionPerformed(const Tizen::Ui::Control& source, int actionId);
	virtual void OnFormBackRequested(Tizen::Ui::Controls::Form& source);
	virtual void OnSceneActivatedN(const Tizen::Ui::Scenes::SceneId& previousSceneId,
								   const Tizen::Ui::Scenes::SceneId& currentSceneId, Tizen::Base::Collection::IList* pArgs);
	virtual void OnSceneDeactivated(const Tizen::Ui::Scenes::SceneId& currentSceneId,
									const Tizen::Ui::Scenes::SceneId& nextSceneId);
	virtual void OnAudioInBufferIsFilled( Tizen::Base::ByteBuffer* pData);
	virtual void OnAudioInInterrupted(void) {}
	virtual void OnAudioInReleased(void) {}
	virtual void OnAudioInErrorOccurred(result r) {}
	virtual void OnAudioInAudioFocusChanged(void) {}
	virtual void OnTransactionCertVerificationRequiredN(HttpSession& httpSession, HttpTransaction& httpTransaction, Tizen::Base::String* pCert) {}
	virtual void OnTransactionReadyToWrite(HttpSession& httpSession, HttpTransaction& httpTransaction, int recommendedChunkSize) {}
	virtual void OnTransactionReadyToRead(HttpSession& httpSession, HttpTransaction& httpTransaction, int availableBodyLen) {}
	virtual void OnTransactionAborted(HttpSession& httpSession, HttpTransaction& httpTransaction, result r) {}
	virtual void OnTransactionCompleted(HttpSession& httpSession, HttpTransaction& httpTransaction);
	virtual void OnTransactionHeaderCompleted(HttpSession& httpSession, HttpTransaction& httpTransaction, int headerLen, bool bAuthRequired) {}

protected:
	static const int ID_BUTTON_OK = 101;
	Tizen::Media::AudioIn audioIn;
	Tizen::Base::ByteBuffer audioBuffer[MAX_BUFFER_COUNT];
	HttpSession *httpSession;

};

#endif	//_EYRIE_MAIN_FORM_H_
